﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
//--------

using System.Windows.Messaging;
using System.Windows.Browser; // HtmlPage, for Invoke (the click)
using System.Threading;
using System.Windows.Threading; // dispatcheroperation




namespace SilverCalc
{
    public partial class MainPage : UserControl
    {

        LocalMessageSender lms = null;
        public MainPage()
        {
            InitializeComponent();
            //
            try
            {
                LocalMessageReceiver lmr = new LocalMessageReceiver("AppReceiver", ReceiverNameScope.Global, LocalMessageReceiver.AnyDomain);
                lmr.MessageReceived += AppMessageReceivedHandler;
                lmr.Listen();

                lms = new LocalMessageSender("HarnessReceiver", LocalMessageSender.Global);
                lms.SendCompleted += AppSendCompletedHandler;
            }
            catch (Exception ex)
            {
                textBox3.Text = ex.Message;
            }
        }

       

        private void AppMessageReceivedHandler(object sender, MessageReceivedEventArgs e)
        {
            string message = e.Message;
            
            if (message.StartsWith("data"))
            {
              //string testCaseInput = e.Message;
              string[] tokens = message.Split(':');

              // tokens[0] == 'data' -> discard
              string input1 = tokens[1];
              string input2 = tokens[2];
              string operation = tokens[3];

              textBox1.Text = input1;
              textBox2.Text = input2;

              if (operation == "Multiply")
              {
                radioButton1.IsChecked = true;
              }
              else if (operation == "Divide")
              {
                radioButton2.IsChecked = true;
              }

              //HtmlPage.Window.Dispatcher.BeginInvoke(delegate { button1_Click(null, null); }); // async call - returns immediately
              button1.Dispatcher.BeginInvoke(delegate { button1_Click(null, null); });
              

            }

            else if (message == "response")
            {
                string actual = textBox3.Text;
                lms.SendAsync(actual);
            }

        }

        private void AppSendCompletedHandler(object sender, SendCompletedEventArgs e)
        {
            // todo
        }


        private void button1_Click(object sender, RoutedEventArgs e)
        {
            double x = double.Parse(textBox1.Text);
            double y = double.Parse(textBox2.Text);
            double result = 0;
            if (radioButton1.IsChecked == true)
                result = x * y;
            else if (radioButton2.IsChecked == true)
                result = x / y;
            textBox3.Text = result.ToString("0.0000");
        }
    }
}
