﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
//-----------
using System.Windows.Messaging;

namespace TestHarness
{
    public partial class MainPage : UserControl
    {
        LocalMessageSender lms = null;
        private string[] testCases = new string[] {
            "001:2.5:3.0:Multiply:7.5000",
            "002:8.6:2.0:Divide:4.3000"
        };
        private string caseID;
        private string input1;
        private string input2;
        private string operation;
        private string expected;

        public MainPage()
        {
            InitializeComponent();

            // ---------------
            try
            {
                LocalMessageReceiver lmr = new LocalMessageReceiver("HarnessReceiver", ReceiverNameScope.Global, LocalMessageReceiver.AnyDomain);
                lmr.MessageReceived += HarnessMessageReceivedHandler;
                lmr.Listen();

                lms = new LocalMessageSender("AppReceiver", LocalMessageSender.Global);
                lms.SendCompleted += HarnessSendCompletedHandler;

                foreach (string testCase in testCases)
                {
                    listBox1.Items.Add(testCase);
                }


            }
            catch (Exception ex)
            {
                listBox1.Items.Add(ex.Message);
            }
        }

        private void HarnessMessageReceivedHandler(object sender, MessageReceivedEventArgs e)
        {
            string actual = e.Message;
            listBox2.Items.Add("Received " + actual + " from application");
            if (actual == expected)
                listBox2.Items.Add("Pass");
            else
                listBox2.Items.Add("**FAIL**");
            listBox2.Items.Add("========================");
        }

        private void HarnessSendCompletedHandler(object sender, SendCompletedEventArgs e)
        {
            // todo
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            string testCaseData = (string)listBox1.SelectedItem;
            string[] tokens = testCaseData.Split(':');
            caseID = tokens[0];
            input1 = tokens[1];
            input2 = tokens[2];
            operation = tokens[3];
            expected = tokens[4];

            string testCaseInput = input1 + ":" + input2 + ":" + operation;

            listBox2.Items.Add("========================");
            listBox2.Items.Add("Test case " + caseID);
            listBox2.Items.Add("Sending '" + testCaseInput + "' to application");
            lms.SendAsync("data" + ":" + testCaseInput);

            System.Threading.Thread.Sleep(1000); // give app time to respond

            lms.SendAsync("response");

        }
    }
}
